"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.databaseProviders = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const database_config_1 = require("./database.config");
const ChannelMatching_entity_1 = require("../mailer/models/ChannelMatching.entity");
const ProductMatching_entity_1 = require("../mailer/models/ProductMatching.entity");
exports.databaseProviders = [{
        provide: 'SequelizeInstance',
        useFactory: async () => {
            let config;
            switch (process.env.NODE_ENV) {
                case 'DEVELOPMENT':
                    config = database_config_1.databaseConfig.development;
                    break;
                case 'TEST':
                    config = database_config_1.databaseConfig.test;
                    break;
                case 'PRODUCTION':
                    config = database_config_1.databaseConfig.production;
                    break;
                default:
                    config = database_config_1.databaseConfig.development;
            }
            const sequelize = new sequelize_typescript_1.Sequelize(config);
            sequelize.addModels([ChannelMatching_entity_1.ChannelMatching, ProductMatching_entity_1.ProductMatching]);
            await sequelize.sync();
            return sequelize;
        },
    }];
//# sourceMappingURL=database.providers.js.map