import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, HasOne, HasMany, Scopes, BelongsTo, BelongsToMany, AfterUpdate, AfterBulkUpdate } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { DataTypes } from 'sequelize/types';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblProductMatching' } as IDefineOptions;

@Table(tableOptions)



export class ProductMatching extends Model<ProductMatching>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productMatchingId: number;

    @Column(DataType.BIGINT)
    channelId: number;

    @Column(DataType.BIGINT)
    contactId: number;

    @Column(DataType.BIGINT)
    productId: number;

    @Column(DataType.DATE)
    createdAt: Date;

    @Column(DataType.DATE)
    deletedAt: Date;

    @Column
    mailStatus: string;

}
