import { Inject, Injectable } from '@nestjs/common';
import { ChannelMatching } from '../models/ChannelMatching.entity';
import { ProductMatching } from '../models/ProductMatching.entity';
const sgMail = require('@sendgrid/mail');

@Injectable()
export class MailerService {

  constructor(
    @Inject('ChannelMatchingRepository') private readonly channelMatchingRepository: typeof ChannelMatching,
    @Inject('ProductMatchingRepository') private readonly productMatchingRepository: typeof ProductMatching,
  ) {
    sgMail.setApiKey(process.env.SENDGRID_API_KEY);
    //sgMail.setSubstitutionWrappers("{{", "}}");
  }

  async sendEmail(data) {
    console.log("data:", data);
    //send the email
    sgMail.send(data, (error, result) => {
      if (error) {
        console.log(error);
      } else {
        console.log("That's wassup!");
      }
    });
  }

  async sendChannelSuggestion(data, suggestion) {
    //console.log("data:", data);
    //send the email
    sgMail.send(data, (error, result) => {
      if (error) {
        console.log(error);
      } else {
        //console.log("That's wassup!");
        //console.log("suggestion:", suggestion);
        this.channelMatchingRepository.bulkCreate(suggestion);
      }
    });
  }

  async sendProductSuggestion(data, suggestion) {
    //console.log("data:", data);
    //send the email
    sgMail.send(data, (error, result) => {
      if (error) {
        console.log(error);
      } else {
        //console.log("That's wassup!");
        //console.log("suggestion:", suggestion);

        this.productMatchingRepository.bulkCreate(suggestion);
      }
    });
  }


}
